
#include "uart.h"


// *************************************************************************
void uputs (unsigned char *s){		//string senden
	
  while(*s) uputc(*s++);				//sendet zeichenkette, bis ende.. '\0'    
  
}
// *************************************************************************
void ugets(char* Buffer, unsigned char MaxLen){	// zeichenkette holen
  unsigned char NextChar;
  unsigned char StringLen = 0;
 
  NextChar = ugetc();         		// Warte auf und empfange das nächste Zeichen  
                                
  while( NextChar != '\n' && StringLen < MaxLen - 1 ) {		//string ende oder puffer voll
    *Buffer++ = NextChar;
    StringLen++;
    NextChar = ugetc();
  }
   
  *Buffer = '\0';					//string abschluss
}
// *************************************************************************
void uputc(unsigned char c){

  while (!(USART2->SR & USART_FLAG_TXE));
  USART2->DR = (c & 0xFF);
}

// *************************************************************************
unsigned char ugetc(){

  while (!(USART2->SR & USART_FLAG_RXNE));
  return ((unsigned char)(USART2->DR & 0xFF));
}

// *************************************************************************
void uart_init(unsigned long baud){

	// config struct's
	GPIO_InitTypeDef GPIO_InitStructure_uart;
	USART_InitTypeDef USART_InitStructure;
	
	// enable clocks (pins and uart itself)
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_AFIO, ENABLE);   
  	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE); 	
   	
	// uart rx pin		 
	GPIO_InitStructure_uart.GPIO_Pin = GPIO_Pin_3;
	GPIO_InitStructure_uart.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOA, &GPIO_InitStructure_uart);

	// uart tx pin
	GPIO_InitStructure_uart.GPIO_Pin = GPIO_Pin_2;
	GPIO_InitStructure_uart.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure_uart.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOA, &GPIO_InitStructure_uart);

	// uart functionality			
 	USART_InitStructure.USART_BaudRate = baud;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
 	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;

	USART_Init(USART2, &USART_InitStructure);
	USART_Cmd(USART2, ENABLE); 
}



